package betterwithmods.client.baking;

import betterwithmods.BWMod;
import betterwithmods.client.model.render.RenderUtils;
import betterwithmods.common.blocks.camo.BlockCamo;
import betterwithmods.common.blocks.camo.CamoInfo;
import com.google.common.collect.ImmutableMap;
import net.minecraft.client.renderer.block.model.IBakedModel;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.client.renderer.block.model.ModelRotation;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockRenderLayer;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.client.model.IModel;
import net.minecraftforge.common.model.TRSRTransformation;

public class BarkModel extends ModelFactory<CamoInfo> {

    public static final ModelResourceLocation LOCATION = new ModelResourceLocation(new ResourceLocation(BWMod.MODID, "bark"), "inventory");

    public static BarkModel BARK;

    public final IModel template;

    public BarkModel(IModel template) {
        super(BlockCamo.CAMO_INFO, TextureMap.field_174945_f);
        this.template = template;
    }

    @Override
    public IBakedModel bake(CamoInfo object, boolean isItem, BlockRenderLayer layer) {
        ImmutableMap.Builder<String, String> textures = new ImmutableMap.Builder<>();
        textures.put("layer0", RenderUtils.getParticleTexture(object.getState()).func_94215_i());
        TRSRTransformation state = TRSRTransformation.from(ModelRotation.X0_Y0);
        IModel retexture = template.retexture(textures.build()).uvlock(true);
        return new WrappedBakedModel(retexture.bake(state, DefaultVertexFormats.field_176600_a, RenderUtils.textureGetter), RenderUtils.getParticleTexture(object.getState())).addDefaultBlockTransforms();
    }

    @Override
    public CamoInfo fromItemStack(ItemStack stack) {
        return new CamoInfo(stack);
    }
}
