package betterwithmods.client.container.bulk;

import betterwithmods.client.container.ContainerProgress;
import betterwithmods.common.tile.TileMill;
import betterwithmods.util.CapabilityUtils;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IContainerListener;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraftforge.items.IItemHandler;
import net.minecraftforge.items.SlotItemHandler;

import javax.annotation.Nonnull;

public class ContainerMill extends ContainerProgress {
    private final TileMill tile;
    public boolean blocked;

    public ContainerMill(EntityPlayer player, TileMill tile) {
        super(tile);
        this.tile = tile;

        for (int j = 0; j < 3; j++) {
            func_75146_a(new SlotItemHandler(tile.inventory, j, 62 + j * 18, 43));
        }

        IItemHandler playerInv = CapabilityUtils.getEntityInventory(player);

        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < 9; j++) {
                func_75146_a(new SlotItemHandler(playerInv, j + i * 9 + 9, 8 + j * 18, 76 + i * 18));
            }
        }

        for (int i = 0; i < 9; i++) {
            func_75146_a(new SlotItemHandler(playerInv, i, 8 + i * 18, 134));
        }
    }

    @Override
    public boolean func_75145_c(@Nonnull EntityPlayer player) {
        return tile.isUseableByPlayer(player);
    }

    @Nonnull
    @Override
    public ItemStack func_82846_b(EntityPlayer player, int index) {
        ItemStack stack = ItemStack.field_190927_a;
        Slot slot = this.field_75151_b.get(index);

        if (slot != null && slot.func_75216_d()) {
            ItemStack stack1 = slot.func_75211_c();
            stack = stack1.func_77946_l();

            if (index < 3) {
                if (!func_75135_a(stack1, 3, this.field_75151_b.size(), true))
                    return ItemStack.field_190927_a;
            } else if (!func_75135_a(stack1, 0, 3, false))
                return ItemStack.field_190927_a;
            if (stack1.func_190916_E() == 0)
                slot.func_75215_d(ItemStack.field_190927_a);
            else
                slot.func_75218_e();
        }
        return stack;
    }


    @Override
    public void func_75132_a(IContainerListener listener) {
        super.func_75132_a(listener);
        listener.func_71112_a(this, 2, this.tile.blocked ? 1 : 0);
    }

    @Override
    public void func_75142_b() {
        super.func_75142_b();
        boolean b = tile.blocked;
        if (blocked != b) {
            blocked = b;
            for (IContainerListener craft : this.field_75149_d) {
                craft.func_71112_a(this, 2, blocked ? 1 : 0);
            }
        }
    }

    @Override
    public void func_75137_b(int index, int value) {
        super.func_75137_b(index, value);
        switch (index) {
            case 2:
                blocked = value == 1;
                break;
        }
    }

}
