package betterwithmods.common.blocks;

import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyEnum;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import javax.annotation.Nonnull;

public class BWMBlockAxis extends BWMBlock {

    public static final PropertyEnum<EnumFacing.Axis> AXIS = PropertyEnum.func_177709_a("axis", EnumFacing.Axis.class);
    public static final EnumFacing.Axis[] VALUES = EnumFacing.Axis.values();

    public BWMBlockAxis(Material material) {
        super(material);
    }

    @Nonnull
    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, AXIS);
    }

    @SuppressWarnings("deprecation")
    @Nonnull
    @Override
    public IBlockState func_176203_a(int meta) {
        return func_176223_P().func_177226_a(AXIS, VALUES[meta]);
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(AXIS).ordinal();
    }

    @Nonnull
    @Override
    public IBlockState getStateForPlacement(@Nonnull World world, @Nonnull BlockPos pos, @Nonnull EnumFacing facing, float hitX, float hitY, float hitZ, int meta, @Nonnull EntityLivingBase placer, EnumHand hand) {
        return super.getStateForPlacement(world, pos, facing, hitX, hitY, hitZ, meta, placer, hand).func_177226_a(AXIS, facing.func_176740_k());
    }

    @Override
    public boolean rotateBlock(net.minecraft.world.World world, @Nonnull BlockPos pos, @Nonnull EnumFacing axis) {
        net.minecraft.block.state.IBlockState state = world.func_180495_p(pos);
        for (net.minecraft.block.properties.IProperty<?> prop : state.func_177228_b().keySet()) {
            if (prop.func_177701_a().equals("axis")) {
                world.func_175656_a(pos, state.func_177231_a(prop));
                return true;
            }
        }
        return false;
    }

}
