package betterwithmods.common.blocks;

import betterwithmods.util.TooltipLib;
import betterwithmods.util.player.PlayerHelper;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.util.ITooltipFlag;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import javax.annotation.Nullable;
import java.util.List;

/**
 * Created by primetoxinz on 6/24/17.
 */
public interface IRotate {

    default boolean rotates() {
        return false;
    }

    default void addInformation(ItemStack stack, @Nullable World player, List<String> tooltip, ITooltipFlag advanced) {
        if (rotates()) {
            tooltip.add(TooltipLib.getTooltip(TooltipLib.ROTATE_WITH_HAND));
        }
    }

    default void nextState(World world, BlockPos pos, IBlockState state) {
    }

    default boolean onBlockActivated(Block block, World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing facing, float hitX, float hitY, float hitZ) {
        if (!rotates())
            return false;

        if (PlayerHelper.areHandsEmpty(player) && player.func_70093_af()) {
            world.func_184133_a(null, pos, block.getSoundType(state, world, pos, player).func_185841_e(), SoundCategory.BLOCKS, 1.0F, world.field_73012_v.nextFloat() * 0.1F + 0.9F);
            nextState(world, pos, state);
            world.func_175685_c(pos, block, false);
            world.func_180497_b(pos, block, 10, 5);
            return true;
        }
        return false;
    }

}
