package betterwithmods.common.blocks.mechanical.mech_machine;

import betterwithmods.BWMod;
import betterwithmods.api.block.IOverpower;
import betterwithmods.common.blocks.BWMBlock;
import betterwithmods.common.blocks.mechanical.IBlockActive;
import betterwithmods.util.InvUtils;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.IStringSerializable;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.items.CapabilityItemHandler;

import javax.annotation.Nonnull;
import java.util.Arrays;

public abstract class BlockMechMachine extends BWMBlock implements IBlockActive, IOverpower {


    private final ResourceLocation overpowerDrops;

    public BlockMechMachine(Material material, ResourceLocation overpowerDrops) {
        super(material);
        this.overpowerDrops = overpowerDrops;
        this.func_149675_a(true);
        this.func_149711_c(3.5F);
        this.func_180632_j(this.field_176227_L.func_177621_b().func_177226_a(ACTIVE, false));
    }

    @Override
    public void func_176213_c(World world, BlockPos pos, IBlockState state) {
        super.func_176213_c(world, pos, state);
        world.func_180497_b(pos, this, func_149738_a(world), 5);
    }

    @Override
    public int func_149738_a(World worldIn) {
        return 10;
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing side, float hitX, float hitY, float hitZ) {
        if (!world.field_72995_K) {
            boolean isInventory = Arrays.stream(EnumFacing.field_82609_l).anyMatch(f -> world.func_175625_s(pos).hasCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, f));
            if (!player.func_70093_af() && world.func_175625_s(pos) != null && isInventory) {
                player.openGui(BWMod.instance, 0, world, pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p());
            }
            return true;
        }
        return true;
    }

    @Override
    public boolean hasTileEntity(IBlockState state) {
        return true;
    }

    @Nonnull
    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, ACTIVE);
    }

    @Nonnull
    @Override
    public IBlockState func_176203_a(int meta) {
        return func_176223_P().func_177226_a(ACTIVE, meta == 1);
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(ACTIVE) ? 1 : 0;
    }

    @Override
    public void overpower(World world, BlockPos pos) {
        overpowerSound(world, pos);
        InvUtils.ejectBrokenItems(world, pos.func_177972_a(EnumFacing.func_176741_a(world.field_73012_v)), overpowerDrops);
        world.func_175698_g(pos);
    }

    public enum EnumType implements IStringSerializable {
        MILL(0, "mill", true),
        PULLEY(1, "pulley", true),
        HOPPER(2, "hopper"),
        TURNTABLE(3, "turntable", true);

        private static final BlockMechMachine.EnumType[] META_LOOKUP = values();

        private final int meta;
        private final String name;
        private final boolean solidity;

        EnumType(int meta, String name) {
            this(meta, name, false);
        }

        EnumType(int meta, String name, boolean solid) {
            this.meta = meta;
            this.name = name;
            this.solidity = solid;
        }

        public static BlockMechMachine.EnumType byMeta(int meta) {
            return META_LOOKUP[meta % META_LOOKUP.length];
        }

        @Nonnull
        @Override
        public String func_176610_l() {
            return name;
        }

        public int getMeta() {
            return meta;
        }

        public boolean getSolidity() {
            return solidity;
        }
    }
}
