package betterwithmods.common.entity.ai.eat;

import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.Ingredient;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;

import java.util.List;
import java.util.Optional;

/**
 * Created by primetoxinz on 4/22/17.
 */
public abstract class EntityAIEatFood<T extends EntityLivingBase> extends EntityAIBase {
    protected T entity;
    private Ingredient validItem;
    private EntityItem targetItem;

    private double distance;

    public EntityAIEatFood(T entity, Ingredient validItem, double distance) {
        this.entity = entity;
        this.validItem = validItem;
        this.distance = distance;
    }

    private Optional<EntityItem> getTargetItem(List<EntityItem> items) {
        if (items.isEmpty())
            return Optional.empty();
        EntityItem target = null;
        for (EntityItem item : items) {
            if (validItem.apply(item.func_92059_d())) {
                target = item;
                break;
            }
        }
        return Optional.ofNullable(target);
    }

    @Override
    public void func_75251_c() {
        targetItem = null;
    }

    @Override
    public boolean func_75250_a() {
        if (!isReady())
            return false;

        BlockPos entityPos = entity.func_180425_c();
        if (targetItem == null) {
            List<EntityItem> entityItems = entity.func_130014_f_().func_175647_a(EntityItem.class, new AxisAlignedBB(entityPos, entityPos.func_177982_a(1, 1, 1)).func_186662_g(distance), entity -> entity != null && entity.field_70122_E);
            targetItem = getTargetItem(entityItems).orElse(null);
        }

        if (targetItem != null) {
            BlockPos targetPos = targetItem.func_180425_c();
            if (entityPos.func_185332_f(targetPos.func_177958_n(), targetPos.func_177956_o(), targetPos.func_177952_p()) <= distance) {
                processItemEating();
                return false;
            } else {
                return true;
            }
        }
        return false;
    }

    public abstract boolean isReady();

    public abstract void onEaten(ItemStack food);

    @Override
    public boolean func_75253_b() {
        return func_75250_a();
    }

    private void processItemEating() {
        if (targetItem != null) {
            ItemStack foodStack = targetItem.func_92059_d();
            if (!foodStack.func_190926_b())
                onEaten(foodStack);
        }
    }
}
