package betterwithmods.common.registry.anvil;

import betterwithmods.common.registry.base.CraftingManagerBase;
import net.minecraft.inventory.InventoryCrafting;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.CraftingManager;
import net.minecraft.item.crafting.IRecipe;
import net.minecraft.util.NonNullList;
import net.minecraft.world.World;

import javax.annotation.Nonnull;
import java.util.List;

public class CraftingManagerAnvil extends CraftingManagerBase<IRecipe> {

    private IRecipe recipe;

    /**
     * Retrieves an ItemStack that has multiple recipes for it.
     */
    public ItemStack findMatchingResult(InventoryCrafting inventory, World world) {

        if (recipe != null && recipe.func_77569_a(inventory, world)) {
            return recipe.func_77572_b(inventory);
        }

        for (IRecipe irecipe : recipes) {
            if (irecipe.func_77569_a(inventory, world)) {
                recipe = irecipe;
                return irecipe.func_77572_b(inventory);
            }
        }

        for (IRecipe irecipe : CraftingManager.field_193380_a) {
            if (irecipe.func_77569_a(inventory, world)) {
                recipe = irecipe;
                return irecipe.func_77572_b(inventory);
            }
        }

        return ItemStack.field_190927_a;
    }


    public NonNullList<ItemStack> getRemainingItems(InventoryCrafting inventory, World craftMatrix) {

        if (recipe != null && recipe.func_77569_a(inventory, craftMatrix)) {
            return recipe.func_179532_b(inventory);
        }

        for (IRecipe irecipe : recipes) {
            if (irecipe.func_77569_a(inventory, craftMatrix)) {
                recipe = irecipe;
                return irecipe.func_179532_b(inventory);
            }
        }

        for (IRecipe irecipe : CraftingManager.field_193380_a) {
            if (irecipe.func_77569_a(inventory, craftMatrix)) {
                recipe = irecipe;
                return irecipe.func_179532_b(inventory);
            }
        }

        NonNullList<ItemStack> nonnulllist = NonNullList.func_191197_a(inventory.func_70302_i_(), ItemStack.field_190927_a);

        for (int i = 0; i < nonnulllist.size(); ++i) {
            nonnulllist.set(i, inventory.func_70301_a(i));
        }

        return nonnulllist;
    }


    @Override
    public List<IRecipe> getDisplayRecipes() {
        return recipes;
    }

    @Override
    public IRecipe addRecipe(@Nonnull IRecipe recipe) {
        this.recipes.add(recipe);
        return recipe;
    }
}
