package betterwithmods.common.world;

import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.gen.structure.MapGenMineshaft;
import net.minecraft.world.gen.structure.StructureComponent;
import net.minecraft.world.gen.structure.StructureStart;
import net.minecraftforge.common.BiomeDictionary;

import javax.annotation.Nonnull;
import java.util.Random;

public class BWMapGenMineshaft extends MapGenMineshaft {
    @Nonnull
    @Override
    protected StructureStart func_75049_b(int chunkX, int chunkZ) {

        Biome biome = field_75039_c.func_180494_b(new BlockPos((chunkX << 4) + 8, 64, (chunkZ << 4) + 8));
        MapGenMineshaft.Type type = BiomeDictionary.hasType(biome, BiomeDictionary.Type.MESA) ? MapGenMineshaft.Type.MESA : MapGenMineshaft.Type.NORMAL;
        return new BWStructureMineshaftStart(this.field_75039_c, this.field_75038_b, chunkX, chunkZ, type);
    }

    public static class BWStructureMineshaftStart extends StructureStart {
        private MapGenMineshaft.Type mineShaftType;

        public BWStructureMineshaftStart() {
        }

        public BWStructureMineshaftStart(World world, Random random, int chunkX, int chunkZ, MapGenMineshaft.Type type) {
            super(chunkX, chunkZ);
            this.mineShaftType = type;
            BWStructureMineshaftPieces.Room room = new BWStructureMineshaftPieces.Room(0, random, (chunkX << 4) + 2, (chunkZ << 4) + 2, this.mineShaftType);
            this.field_75075_a.add(room);
            room.func_74861_a(room, this.field_75075_a, random);
            this.func_75072_c();

            if (type == MapGenMineshaft.Type.MESA) {
                int yoffset = world.func_181545_F() - this.field_75074_b.field_78894_e + this.field_75074_b.func_78882_c() / 2 + 5;
                this.field_75074_b.func_78886_a(0, yoffset, 0);

                for (StructureComponent structurecomponent : this.field_75075_a) {
                    structurecomponent.func_181138_a(0, yoffset, 0);
                }
            } else {
                this.func_75067_a(world, random, 10);
            }
        }
    }
}
