package betterwithmods.module.gameplay.miniblocks;

import betterwithmods.common.BWMRecipes;
import betterwithmods.module.gameplay.miniblocks.blocks.BlockMini;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.inventory.InventoryCrafting;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.IRecipe;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.world.World;
import net.minecraftforge.registries.IForgeRegistryEntry;

import javax.annotation.Nonnull;

public class MiniRecipe extends IForgeRegistryEntry.Impl<IRecipe> implements IRecipe {

    public final Block start;
    public final Block end;

    public MiniRecipe(Block start, Block end) {
        this.start = start;
        this.end = end;
        setRegistryName(start.getRegistryName());
    }

    @Override
    public boolean func_77569_a(@Nonnull InventoryCrafting inv, @Nonnull World worldIn) {
        ItemStack[] stacks = new ItemStack[2];
        int matches = 0;
        for (int x = 0; x < inv.func_70302_i_(); x++) {
            boolean inRecipe = false;
            ItemStack stack = inv.func_70301_a(x);
            if (!stack.func_190926_b()) {
                if (stack.func_77973_b() instanceof ItemCamo && matches <= 1) {
                    Block block = ((ItemCamo) stack.func_77973_b()).func_179223_d();
                    if (block == start) {
                        stacks[matches] = stack;
                        inRecipe = true;
                        matches++;
                    }
                }
                if (!inRecipe)
                    return false;
            }

        }
        return ItemCamo.matches(stacks[0], stacks[1]);
    }

    @Nonnull
    @Override
    public ItemStack func_77572_b(@Nonnull InventoryCrafting inv) {
        ItemStack first = ItemStack.field_190927_a;
        for (int x = 0; x < inv.func_70302_i_(); x++) {
            ItemStack stack = inv.func_70301_a(x);
            if (!stack.func_190926_b()) {
                if (stack.func_77973_b() instanceof ItemCamo) {
                    first = stack;
                    break;
                }
            }
        }
        return getOutput(first);
    }

    @Override
    public boolean func_194133_a(int width, int height) {
        return (width * height) >= 2;
    }

    @Nonnull
    public ItemStack func_77571_b() {
        return ItemStack.field_190927_a;
    }

    public ItemStack getStart() {
        return new ItemStack(start);
    }

    public ItemStack getEnd() {
        return new ItemStack(end);
    }

    public ItemStack getOutput(ItemStack input) {
        ItemStack result = ItemStack.field_190927_a;
        if (!input.func_190926_b()) {
            if (end instanceof BlockMini) {
                result = new ItemStack(end);
                NBTTagCompound tag = input.func_77978_p();
                result.func_77982_d(tag);
            } else {
                IBlockState state = ItemCamo.getState(input);
                if (state != null)
                    result = BWMRecipes.getStackFromState(state);
            }
        }
        return result;

    }
}
