package betterwithmods.util;

import net.minecraft.enchantment.Enchantment;
import net.minecraft.enchantment.EnumEnchantmentType;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraftforge.fml.relauncher.ReflectionHelper;

import javax.annotation.Nonnull;

public class InfernalEnchantment extends Enchantment {

    private Enchantment enchantment;
    private int minLevel, maxLevel;
    private int id;

    public InfernalEnchantment(@Nonnull Enchantment enchantment) {
        super(enchantment.func_77324_c(), enchantment.field_77351_y, getSlots(enchantment));
        this.enchantment = enchantment;
        this.maxLevel = enchantment.func_77325_b();
        this.minLevel = enchantment.func_77319_d();
        this.id = Enchantment.func_185258_b(enchantment);
    }

    private static EntityEquipmentSlot[] getSlots(Enchantment enchantment) {
        return ReflectionHelper.getPrivateValue(Enchantment.class, enchantment, ReflectionLib.ENCHANTMENT_APPLICIBLE_EQUIPMENT_TYPES);
    }

    @Override
    public int func_77325_b() {
        return maxLevel;
    }

    @Override
    public int func_77319_d() {
        return minLevel;
    }

    public InfernalEnchantment setMinLevel(int minLevel) {
        this.minLevel = minLevel;
        return this;
    }

    public InfernalEnchantment setMaxLevel(int maxLevel) {
        this.maxLevel = maxLevel;
        return this;
    }

    public int getId() {
        return id;
    }
}
